## userbindmount 0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(userbindmount
		VERSION 0.0.1
		DESCRIPTION "bind mount in user namespaces"
		HOMEPAGE_URL "https://github.com/rd235/userbindmount"
		LANGUAGES C)

include(GNUInstallDirs)
add_definitions(-D_GNU_SOURCE)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FORTIFY_SOURCE=2 -O2 -pedantic -Wall -Wextra")

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

find_library(TESTCAP cap)
if(NOT TESTCAP)
	message(FATAL_ERROR "libcap not found")
endif()

add_library(libuserbindmount SHARED libuserbindmount.c)
target_link_libraries(libuserbindmount cap)
set_target_properties(libuserbindmount PROPERTIES
		OUTPUT_NAME "userbindmount"
		VERSION ${PROJECT_VERSION}
		SOVERSION ${PROJECT_VERSION_MAJOR})

add_library(libuserbindmount-static STATIC libuserbindmount.c)
set_target_properties(libuserbindmount-static
		PROPERTIES OUTPUT_NAME userbindmount)

configure_file(userbindmount.pc.in userbindmount.pc @ONLY)

install(TARGETS libuserbindmount
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS libuserbindmount-static
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES userbindmount.h
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/userbindmount.pc
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

add_executable(userbindmount userbindmount.c)
target_link_libraries(userbindmount libuserbindmount cap)

install(TARGETS userbindmount
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_subdirectory(man)

=== man/Makefile ===
RONN=ronn
RONNOK := $(shell command -v ${RONN} 2> /dev/null)

none:

% : %.ronn
ifdef RONNOK
# copy copyright notice
		grep "^\.\\\\\"" $< > $@ || true
# run ronn
		$(RONN) -r ${RONN_ARGS} --pipe $< >> $@
# delete useless trailing "" in .TH
		sed -i '/^\.TH /s/ ""$$//' $@
else
		echo "${RONN} is not available. Manpage $@ cannot be updated" >/dev/stderr >&2
endif

=== debian/changelog ===
userbindmount (0.1-3) unstable; urgency=medium

  [ Renzo Davoli ]
  * fix reproducible-builds: BuildId differences triggered by RPATH 
    (Closes: #1001850)
  [ Andrea Capriotti]
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Andrea Capriotti <capriott@debian.org>  Fri, 12 Aug 2022 15:45:51 +0200

userbindmount (0.1-2) unstable; urgency=medium

  * d/control: Set Maintainer to Debian VirtualSquare Team
  * d/control: Fix Vcs
  * Initial Debian release (Closes: #965296)

 -- Andrea Capriotti <capriott@debian.org>  Sun, 19 Jul 2020 01:35:16 +0200

userbindmount (0.1-1) unstable; urgency=medium

  * Initial release

 -- Renzo Davoli <renzo@cs.unibo.it>  Sun, 05 Jul 2020 20:11:27 +0200

=== debian/control ===
Source: userbindmount
Priority: optional
Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
Uploaders: Mattia Biondi <mattiabiondi1@gmail.com>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.12), libcap-dev
Standards-Version: 4.6.1
Section: libs
Homepage: http://www.virtualsquare.org/
Vcs-Git: https://salsa.debian.org/virtualsquare-team/userbindmount.git
Vcs-Browser: https://salsa.debian.org/virtualsquare-team/userbindmount
Rules-Requires-Root: no

Package: libuserbindmount-dev
Section: libdevel
Architecture: any
Depends: libuserbindmount0 (= ${binary:Version}), ${misc:Depends}
Description: bind-mount in user namespaces (devel)
 Bind mount files and create user namespaces where bind mount is allowed
 as users. It does not need root access or specific capabilities to run
 (provided user-namespaces are supported)
 .
 This package contains the development files used for C programs.

Package: libuserbindmount0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libcap2
Description: bind-mount in user namespaces (library)
 Bind mount files and create user namespaces where bind mount is allowed
 as users. It does not need root access or specific capabilities to run
 (provided user-namespaces are supported)
 .
 This package contains the shared library.

Package: userbindmount
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libuserbindmount0
Description: bind-mount in user namespaces (command)
 Bind mount files and create user namespaces where bind mount is allowed
 as users. It does not need root access or specific capabilities to run
 (provided user-namespaces are supported)
 .
 This package contains the user command based on libuserbindmount.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON

override_dh_auto_install:
	dh_auto_install --destdir debian/tmp
